cls

rem call \javaenv.bat

rem Compile a Scala program to dot Net
rem (using scala-msil, and dot Net Compilers)
rem Important: scala sources must be encoded using UTF-8, or the encoding must be specified

rem add required scala extensions to the scala installation
rem sbaz install scala-msil


rem 
rem note for Scala-2.7.7: the env var ILASM must NOT be defined, or scalac-net currently fails
rem rem set ILASM_HOME=C:\Windows\Microsoft.NET\Framework\v2.0.50727\
rem set ILASM_HOME=C:\WINDOWS\Microsoft.NET\Framework\v4.0.30319\
rem set PATH=%PATH%;%ILASM_HOME%
rem 
rem 
rem note that in Scala-2.8.0 scalac-net gives this error: 
rem scala.tools.nsc.MissingRequirementError: class scala.runtime.VolatileBooleanRef not found.
rem But note that the current trick doesn't solve ... at least with the current release
rem 
rem set PATH=%PATH%;%SCALA_HOME%\lib
rem set CLASSPATH=%CLASSPATH%;%SCALA_HOME%\lib\scala-library.jar


rem check required executables:
rem scala -version
rem ilasm


rem prepare a deploy folder
mkdir deploy
del deploy\*.* /Q
copy %SCALA_HOME%\lib\*.dll .\deploy

rem end environment setup


rem set NAME=%1
set NAME=HelloWorld

rem cleanup
del *.msil  *.exe *.dll /Q
del deploy\%NAME%.* /Q


rem old command, no more valid
rem scalac -target:msil -r "%SCALA_HOME%\lib" %NAME%.scala
rem old command line
rem ilasm /output=%NAME%.exe /quiet %NAME%.msil

rem compile
scalac-net %NAME%.scala

rem compile to exe
rem ilasm %NAME%.msil
ilasm /exe %NAME%.msil

rem compile to dll, optional, depending on case
ilasm /dll %NAME%.msil

rem deploy to a distribution folder 
move /Y %NAME%.exe .\deploy
move /Y %NAME%.dll .\deploy

rem final cleanup
del *.msil


rem test run
deploy\%NAME%.exe

rem pause

